
#include <stdio.h>
#include "myint.h"
#include "aki80.h"
#include "addc.h"

uint dummy;

void initCTC3(void)
{
	outp(CTC3, 0x03);	//_~[R}h
	outp(CTC3, 0x07);	//^C}[h 1/16
	outp(CTC3, 0x2);	//TimeConstant, 0x49600bps, 0x219200bps
}

//荞ݔΉȂ̂Œ
void initSIOA(void)
{
	outp(SIOA_CMD, SIO_CMD_Null | 0);		//WR0I
	outp(SIOA_CMD, SIO_CMD_ChRst | 0);		//Zbg
	outp(SIOA_CMD, SIO_CMD_RstExtInt | 4);	//RR0ZbgAWR4I
	outp(SIOA_CMD, 0x44);					//x16Clock, 1Stop, NoParity
	outp(SIOA_CMD, SIO_CMD_Null | 3);		//WR3I
	outp(SIOA_CMD, 0xc1);					//MWbits, 
	outp(SIOA_CMD, SIO_CMD_Null | 5);		//WR5I
	outp(SIOA_CMD, 0x68);					//MWbits, 
}

int SIOA_getc(void)
{
	volatile uchar status=inp(SIOA_CMD);
	volatile uchar error;
	if((status & 0x01)==0)		return EOF;	//Mf[^Ȃ
	
	outp(SIOA_CMD, SIO_CMD_Null | 1);		//RR1I
	error=inp(SIOA_CMD);
	//G[?
	if(error &= 0x70)		return -(int)error;
	else					return inp(SIOA_DATA);
}

void SIOA_putc(char c)
{
	volatile uchar status;
	do{
		status=inp(SIOA_CMD);
	}while((status & 0x04)==0);
	outp(SIOA_DATA, c);
}

void SIOA_puts(char *s)
{
	while(*s!='\0')
		SIOA_putc(*s++);
	SIOA_putc('\n');
	SIOA_putc('\r');
}

uchar SIOA_transmitNow(void)
{
	volatile uchar status2;
	outp(SIOA_CMD, SIO_CMD_Null | 1);		//WR1I
	status2=inp(SIOA_CMD);
	if(status2 & 0x01)		return 0;
	else					return 1;
}


void main(void)
{
	extern void rst8(void);
	
	initCTC3();
	initSIOA();
	
	SIOA_puts("hello world");

	rst8();		//RST 8h߂sTu[`

	SIOA_puts("From main");
	addc('B');
	
	while(SIOA_transmitNow())
		;
	//MON_RET();
}

/*	荞ݏ[`
 *		WX^̑ޔEA͕svŕKvȏ݂̂LqB
 */
void _RST8(void)
{
	SIOA_puts("From INT");
}

void _RST10(void)
{
}
void _RST18(void)
{
}
void _RST20(void)
{
}
void _RST28(void)
{
}
void _RST30(void)
{
}
void _RST38(void)
{
}
void _NMI(void)
{
}

